#!/bin/bash
# Copyright (c) 1992-2024 ESET, spol. s r.o. All Rights Reserved
# ESET DEM Plugin for NinjaOne - Linux
# Version 2.0.0.0

# --- Setup variables ---
allowUpdate="true"
bin="/opt/ermma/bin"
logs="/opt/ermma/logs"
ermma="$bin/ermma-ninja"
dotnet="DOTNET_BUNDLE_EXTRACT_BASE_DIR=/tmp/.net"

# --- Environment Setup ---
downloadUrl="https://update.esetusa.com/plugin/ermma/ninja/linux/ermma-ninja"

if [ ! -f "$ermma" ]; then
	if [ ! -d $bin ]; then
		mkdir -p $bin
	fi

	if [ ! -d $logs ]; then
		mkdir -p $logs
	fi

# --- OS Architecture Handling ---
	ARCH=$(uname -m)
	if [ "$ARCH" = "aarch64" ]; then
	  # For arm64 or arm64e architecture
	  downloadUrl="${downloadUrl}-arm64"
	else
	  # For any other architecture, assume x64
	  downloadUrl="${downloadUrl}-x64"
	fi  
	wget "$downloadUrl" -O "$ermma" --quiet
elif $allowUpdate; then
	eval $dotnet "$ermma" --check-agent-updates
fi
chmod +x "$ermma"

# --- ESET Command Execution ---
eval $dotnet $ermma $@

exit $?