# Copyright (c) 1992-2024 ESET, spol. s r.o. All Rights Reserved
# ESET DEM Plugin for NinjaOne - Windows
# Version 2.0.0.0

# --- Setup variables ---
$allowUpdate = $true
$codePage = 1252
$pluginPath = [Environment]::GetFolderPath('ProgramFiles') + "\ESET\RMM Adapter\"
$binPath = $pluginPath + "bin\"
$logPath = $pluginPath + "logs\"
$cmdPath = $binPath + "ermma-ninja.exe"

# --- OS Architecture Handling ---
if ([System.Environment]::Is64BitOperatingSystem) {
	$arch = "x64"
} else {
	$arch = "x86"
}

# --- Environment Setup ---
$url = "https://update.esetusa.com/plugin/ermma/ninja/win/ermma-ninja-$($arch).exe"
$updateUrl = "$($url).hash"	
$wc = new-object System.Net.WebClient
Try {
    if (![System.IO.File]::Exists($cmdPath)) {
        md -Force $pluginPath > $null
        md -Force $binPath > $null
        md -Force $logPath > $null
        $wc.downloadfile($url,$cmdPath)
    }
    elseif($allowUpdate)
    {
        $update = & $cmdPath --check-agent-updates
    }
}
Catch {
    Write-Error "Failed to create ESET RMM Adapter environment."
}

# --- Codepage Change ---
# This is meant to fix an issue that can sometimes occur during install and activation task
& chcp $codePage > $null

# --- ESET Command Execution ---
$result = & $cmdPath $args
$result